/*    
		Talking Multimeter
    Copyright (C) 2014 Cristiano Griletti

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


Using Simple SD Audio
Audio signal output is at the following pin:
 - Arduino with ATmega328       (many non-mega Arduinos): Pin 9
 - Arduino with ATmega1280/2560 (many mega Arduinos)    : Pin 44
 
 Using passive speaker:	
    Audio-Pin --- -[100 Ohm resistor]- ---- Speaker ---- GND
    
 Using amplifier / active speaker / line-in etc.:
    Audio-Pin --||--------------[10k resistor]----+----[1k resistor]---- GND
              100nF capacitor                   to amp
 
 See SimpleSDAudio.h or this website for more information:
 http://www.hackerspace-ffm.de/wiki/index.php?title=SimpleSDAudio
*/

#include <SimpleSDAudio.h>
#include "inc.h"

#define DELA 500

//char AudioFileName[16];

// Create static buffer 
#define BIGBUFSIZE (2*512)      // bigger than 2*512 is often only possible on Arduino megas!
uint8_t bigbuf[BIGBUFSIZE];

void setup()
{
 // Open serial communications and wait for port to open:
  Serial.begin(2400);
  
  // Setting the buffer manually for more flexibility
  SdPlay.setWorkBuffer(bigbuf, BIGBUFSIZE); 
  
  //Serial.print(F("\nInitializing SimpleSDAudio V" SSDA_VERSIONSTRING " ..."));  
  
  // If your SD card CS-Pin is not at Pin 4, enable and adapt the following line:
  //SdPlay.setSDCSPin(10);
  
  // Select between SSDA_MODE_FULLRATE or SSDA_MODE_HALFRATE (62.5kHz or 31.25kHz)
  // and the output modes SSDA_MODE_MONO_BRIDGE, SSDA_MODE_MONO or SSDA_MODE_STEREO
  if (!SdPlay.init(SSDA_MODE_FULLRATE | SSDA_MODE_MONO | SSDA_MODE_AUTOWORKER)) {
    while(1)
    {
          analogWrite(9, 1);
          delay(100);
          analogWrite(9, 0);
          delay(200);
      }
  } 
  pinMode(buttonPin, INPUT); 
}

void PlaySync(String fname)
{
  char buff[20];
  //fname = fname + ".afm";
  fname.toCharArray(buff, 14);
  strncat(buff, ".afm", 4); 
  //Serial.print("[");
  //Serial.print(buff);
  //Serial.print("]");
  
  //SdPlay.setFile(buff);
    if(!SdPlay.setFile(buff)) {
    Serial.println(F("Error code: "));
    Serial.println(SdPlay.getLastError());}

  SdPlay.play();
  while(!SdPlay.isStopped()) SdPlay.worker();
}

void loop(void) {
  uint8_t count=0, c, flag;
  
  //Serial.println(F("Files on card:"));
  //SdPlay.dir(&DirCallback);
/*

SdPlay.stop();*/
  
  DoMultimetro();

}



