/*    
		Talking Multimeter
    Copyright (C) 2014 Cristiano Griletti

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//Multimetro
byte Icons1, PrevIcons1 = 0;
byte Icons2, PrevIcons2 = 0;
byte Icons3, PrevIcons3 = 0;
byte Disp[4] = {0,0,0,0};
byte Recvd = 0;


char RawToNum(byte in)
{
  switch(in)
  {
    case num1: return('1');
    case num2: return('2');
    case num3: return('3');
    case num4: return('4');
    case num5: return('5');
    case num6: return('6');
    case num7: return('7');
    case num8: return('8');
    case num9: return('9');
    case num0: return('0');
    case num_: return(' ');
    case numL: return('L');
  }
  return(' ');
}

void DoMultimetro()
{//  ParseMultIn
  if((Recvd == 1))
  {
    //Prima parla la modalità
    if((Icons1 & I1Auto) != (PrevIcons1 & I1Auto))
    {
      PlaySync(F("auto"));
      if(Icons1 & I1Auto)
        PlaySync(F("on"));
      else
        PlaySync(F("off"));
    }
    if(((Icons1 & I1DegC) != (PrevIcons1 & I1DegC)) && (Icons1 & I1DegC)) PlaySync(F("temp"));
    if(((Icons2 & I2diode) != (PrevIcons2 & I2diode)) && (Icons2 & I2diode)) PlaySync(F("diodo"));
    if(((Icons2 & I2beep) != (PrevIcons2 & I2beep)) && (Icons2 & I2beep)) PlaySync(F("conti"));
    if(((Icons2 & I2duty) != (PrevIcons2 & I2duty)) && (Icons2 & I2duty)) PlaySync(F("duty"));
    if(((Icons3 & I3farad) != (PrevIcons3 & I3farad)) && (Icons3 & I3farad)) PlaySync(F("capacita"));
    if(((Icons3 & I3ohm) != (PrevIcons3 & I3ohm)) && (Icons3 & I3ohm)) PlaySync(F("res"));
    if((Icons3 & I3rel) != (PrevIcons3 & I3rel))
    {
      PlaySync(F("offset"));
      if(Icons3 & I3rel)
        PlaySync(F("on"));
      else
        PlaySync(F("off"));
    }
    if(((Icons3 & I3amp) != (PrevIcons3 & I3amp)) && (Icons3 & I3amp)) PlaySync(F("corrente"));
    if(Icons3 & I3amp)
    {
      if(((Icons2 & I2micro) != (PrevIcons2 & I2micro)) && (Icons2 & I2micro)) PlaySync(F("micro"));
      if(((Icons2 & I2milli) != (PrevIcons2 & I2milli)) && (Icons2 & I2milli)) PlaySync(F("milli"));
      if(((Icons2 & I2micro) != (PrevIcons2 & I2micro)) || ((Icons2 & I2milli) != (PrevIcons2 & I2milli))) PlaySync(F("ampere"));
    }
    
    if(((Icons3 & I3volt) != (PrevIcons3 & I3volt)) && (Icons3 & I3volt)) PlaySync(F("tensione"));

    if(((Icons1 & I1AC) != (PrevIcons1 & I1AC)) && (Icons1 & I1AC)) PlaySync(F("ac"));
    if(((Icons1 & I1DC) != (PrevIcons1 & I1DC)) && (Icons1 & I1DC)) PlaySync(F("dc"));

    if(((Icons3 & I3hertz) != (PrevIcons3 & I3hertz)) && (Icons3 & I3hertz)) PlaySync(F("freq"));
    if(((Icons3 & I3batt) != (PrevIcons3 & I3batt)) && (Icons3 & I3batt)) PlaySync(F("batt"));
  
    PrevIcons1 = Icons1;
    PrevIcons2 = Icons2;
    PrevIcons3 = Icons3;
    
    if(!digitalRead(buttonPin))
    {
      //
      ////Lettura numero
      //
      if((Disp[2] & 0x7F) == numL)
      {
        PlaySync(F("overflow"));
      }
      else
      {
        char Num[8] = "0000";
        if(Disp[0] & 0x80) PlaySync(F("-"));
        if(Disp[1] & 0x80) 
        {
          Num[0] = RawToNum(Disp[0] & 0x7F); 
          Num[1] = 0;
          SayNum99(Num);
          PlaySync(F("punto"));
          if((Disp[1] & 0x7F) == num0) 
          {
            PlaySync(F("0"));
            if((Disp[2] & 0x7F) == num0) PlaySync(F("0"));
          }
          Num[0] = RawToNum(Disp[1] & 0x7F); 
          Num[1] = RawToNum(Disp[2] & 0x7F); 
          Num[2] = RawToNum(Disp[3] & 0x7F); 
          Num[3] = 0;
          SayNum999(Num);
        }
        else if(Disp[2] & 0x80) 
        {
          Num[0] = RawToNum(Disp[0] & 0x7F); 
          Num[1] = RawToNum(Disp[1] & 0x7F); 
          Num[2] = 0;
          SayNum99(Num);
          PlaySync(F("punto"));
          if((Disp[2] & 0x7F) == num0) PlaySync(F("0"));
          Num[0] = RawToNum(Disp[2] & 0x7F); 
          Num[1] = RawToNum(Disp[3] & 0x7F); 
          Num[3] = 0;
          SayNum99(Num);
       }
        else if(Disp[3] & 0x80) 
        {
          Num[0] = RawToNum(Disp[0] & 0x7F); 
          Num[1] = RawToNum(Disp[1] & 0x7F); 
          Num[2] = RawToNum(Disp[2] & 0x7F); 
          if(((Disp[0] & 0x7F) == num0) && ((Disp[1] & 0x7F) == num0) && ((Disp[2] & 0x7F) == num0)) PlaySync(F("0"));
          
          Num[3] = 0;
          SayNum999(Num);
          PlaySync(F("punto"));
          Num[0] = RawToNum(Disp[3] & 0x7F); 
          Num[1] = 0;
          SayNum99(Num);
       }
       else
        {
          Num[0] = RawToNum(Disp[0] & 0x7F); 
          Num[1] = RawToNum(Disp[1] & 0x7F); 
          Num[2] = RawToNum(Disp[2] & 0x7F); 
          Num[3] = RawToNum(Disp[3] & 0x7F); 
          Num[4] = 0;
          SayNum9999(Num);
       }     
      }
      
      //Cosa
      if((Icons3 & I3volt) || (Icons3 & I3amp) || (Icons3 & I3ohm) || (Icons3 & I3farad) || (Icons3 & I3hertz)) 
      {
        if(Icons2 & I2micro) PlaySync(F("micro"));
        if(Icons2 & I2nano) PlaySync(F("nano"));
        if(Icons2 & I2kilo) PlaySync(F("k"));
        if(Icons2 & I2milli) PlaySync(F("milli"));
        if(Icons2 & I2duty) PlaySync(F("perc"));
        if(Icons2 & I2mega) PlaySync(F("mega"));
       
        if(Icons3 & I3volt) PlaySync(F("volt"));
        if(Icons3 & I3amp) PlaySync(F("ampere"));
        if(Icons3 & I3ohm) PlaySync(F("ohm"));
        if(Icons3 & I3farad) PlaySync(F("farad"));
        if(Icons3 & I3hertz) PlaySync(F("hertz"));
      }
      
      if(Icons1 & I1DegC) PlaySync(F("gradi"));
      if(Icons2 & I2duty) PlaySync(F("perc"));
    }
    Recvd = 0;  
  }
}

/*SerialEvent occurs whenever a new data comes in the
 hardware serial RX.  This routine is run between each
 time loop() runs, so using delay inside loop can delay
 response.  Multiple bytes of data may be available.
 */
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    byte inChar = Serial.read(); 
    Serial.print(inChar, HEX);
    Serial.print(" ");
    switch(inChar >> 4)
    {
      case 1: Icons1 = (inChar << 4) + (Icons1 & 0x0F); break;
      case 2: Disp[0] = (inChar << 4) + (Disp[0] & 0x0F); break;
      case 3: Disp[0] = (Disp[0] & 0xF0) + (inChar & 0x0F); break;
      case 4: Disp[1] = (inChar << 4) + (Disp[1] & 0x0F); break;
      case 5: Disp[1] = (Disp[1] & 0xF0) + (inChar & 0x0F); break;
      case 6: Disp[2] = (inChar << 4) + (Disp[2] & 0x0F); break;
      case 7: Disp[2] = (Disp[2] & 0xF0) + (inChar & 0x0F); break;
      case 8: Disp[3] = (inChar << 4) + (Disp[3] & 0x0F); break;
      case 9: Disp[3] = (Disp[3] & 0xF0) + (inChar & 0x0F); break;
      case 10: Icons2 = (inChar << 4) + (Icons2 & 0x0F); break;
      case 11: Icons2 = (Icons2 & 0xF0) + (inChar & 0x0F); break;
      case 12: Icons3 = (inChar << 4) + (Icons3 & 0x0F); break;
      case 13: Icons3 = (Icons3 & 0xF0) + (inChar & 0x0F); break;
      case 14: Icons1 = (Icons1 & 0xF0) + (inChar & 0x0F); 
      Serial.println();
    
        Recvd = 1;
      break;
    }
  }
}


